unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, IdBaseComponent,
  IdComponent, IdTCPConnection, IdTCPClient, IdExplicitTLSClientServerBase,
  IdMessageClient, IdPOP3, IdMessage;

type
  TForm1 = class(TForm)
    IdPOP31: TIdPOP3;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    edHost: TEdit;
    edPort: TEdit;
    edUser: TEdit;
    edPassword: TEdit;
    btnConnect: TButton;
    Label5: TLabel;
    Label6: TLabel;
    lbMailCount: TLabel;
    lbMailboxSize: TLabel;
    BtnCheck: TButton;
    MailsList: TMemo;
    procedure btnConnectClick(Sender: TObject);
    procedure IdPOP31Connected(Sender: TObject);
    procedure IdPOP31Disconnected(Sender: TObject);
    procedure BtnCheckClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.btnConnectClick(Sender: TObject);
begin
  if not IdPOP31.Connected then
  begin
    IdPOP31.Host := edHost.Text;
    IdPOP31.Port := StrToInt(edPort.Text);
    IdPOP31.Username := edUser.Text;
    IdPOP31.Password := edPassword.Text;
    IdPOP31.Connect;
  end
  else
    IdPOP31.Disconnect;
end;

procedure TForm1.BtnCheckClick(Sender: TObject);
var MailCount: Integer;
  i: Integer;
  Msg: TIdMessage;
begin
  if IdPop31.Connected then
  begin
    MailCount := IdPOP31.CheckMessages;
    lbMailboxSize.Caption := IntToStr(IdPOP31.RetrieveMailBoxSize) + ' Bytes';
    lbMailCount.Caption := IntToStr(MailCount);

    for i := 1 To MailCount Do
    begin
      Msg := TIdMessage.Create;
      try
        IdPOP31.RetrieveHeader(i, Msg);
        MailsList.Lines.Add(Msg.Subject + ' von ' + Msg.From.Text);
      finally
        Msg.Free;
      end;
    end;
  end;
end;

procedure TForm1.IdPOP31Connected(Sender: TObject);
begin
  btnConnect.Caption := 'Trennen';
end;

procedure TForm1.IdPOP31Disconnected(Sender: TObject);
begin
  btnConnect.Caption := 'Verbinden';
  lbMailCount.Caption := '?';
  lbMailboxSize.Caption := '?';
end;

end.
